--- SCRIPT BY _N_S_ ---

local M = {}

local function getAllVehicles()
	local allVehicle = getObjectsByClass("BeamNGVehicle") or {}

	local currentVehicleId = (be:getPlayerVehicle(0) or {getID=nop}):getID()

	local currentVehicle = {}
	local allVehicles = {}

	for i=1, #allVehicle do
		local veh = allVehicle[i]
		local vehId = veh:getID()
		local displayName = vehId == currentVehicleId and "Current, " or ""

		local name = (((core_vehicle_manager.getVehicleData(vehId) or {}).vdata or {}).information or {}).name or veh:getJBeamFilename() or "unknown"

		local displayName = displayName .. name .. " - " .. vehId .. " (" .. (veh:getDynDataFieldbyName("licenseText", 0) or "") .. ")"

		if vehId == currentVehicleId then
			currentVehicle.id = vehId
			currentVehicle.displayName = displayName
		end

		table.insert(allVehicles, {
			id = vehId,
			displayName = displayName
		})
	end

	return {
		currentVehicle = currentVehicle,
		allVehicles = allVehicles
	}
end

local function onVehicleGroupSpawned()
	guihooks.trigger("Agent_Y_Mechanical_Failure_onVehicleGroupSpawned")
end

local function onVehicleDestroyed()
	guihooks.trigger("Agent_Y_Mechanical_Failure_onVehicleDestroyed")
end

local function onAppLoad() -- If the application is not installed, the trigger is not needed. Tiny optimization :)
	if M.onVehicleGroupSpawned then return end
	M.onVehicleGroupSpawned = onVehicleGroupSpawned

	if M.onVehicleGroupSpawned then return end
	M.onVehicleDestroyed = onVehicleDestroyed
end

M.getAllVehicles = getAllVehicles
M.onAppLoad = onAppLoad
return M