angular.module("beamng.apps").directive("agentyMechanicalFailure", [function () {
  return {
  templateUrl: "/ui/modules/apps/agenty_mechanical_failure/app.html",
  replace: true,
  link: function (scope) {
	scope.breakRandomPart = true;
	scope.deformRandomPart = true;
	scope.igniteRandomPart = false;
	scope.breakRandomBeam = true;
	scope.deformRandomBeam = true;
	scope.deflateRandomTire = false;

	scope.ignoreEngineMounts = true;
	scope.ignoreRadiatorAndOilpan = true;
	scope.toggleRandomExplosion = false;
	scope.toggleRealisticDamage = true;
	scope.engineDeformationOnly = false;
	scope.lowerTireDeflationChance = false;

	scope.breakRandomPartWheels = false;
	scope.breakRandomBeamWheels = true;
	scope.deformRandomBeamWheels = true;

	scope.secondsBetweenFailures = 10;

	let IDList = {};

	function UpdateVehicleList() {
		bngApi.engineLua("scripts_agenty__mechanical__failure__app_extension.getAllVehicles()", (data) => {
			const currentVehicle = data.currentVehicle;
			const allVehicles = data.allVehicles;

			IDList = {};
			scope.agentyMechanicalFailureVehList = [];

			for (let i in allVehicles) {
				const vehData = allVehicles[i];

				IDList[vehData.displayName] = vehData.id
				scope.agentyMechanicalFailureVehList.push(vehData.displayName)
			};

			setTimeout(()=>{
				scope.agentyMechanicalFailureVeh = currentVehicle.displayName
				setTimeout(()=>{
					scope.agentyMechanicalFailureVeh = currentVehicle.displayName
				},100) //Sometimes it doesn't install the first time. No idea why, VERY likely a bug.
			}, 250)
		})
	};

	bngApi.engineLua("scripts_agenty__mechanical__failure__app_extension.onAppLoad()");
	UpdateVehicleList()
	scope.$on("VehicleReset", UpdateVehicleList);
	scope.$on("VehicleFocusChanged", UpdateVehicleList);
	scope.$on("Agent_Y_Mechanical_Failure_onVehicleGroupSpawned", UpdateVehicleList);
	scope.$on("Agent_Y_Mechanical_Failure_onVehicleDestroyed", UpdateVehicleList);

	const keyArray1 = [
		"breakRandomPart",
		"deformRandomPart",
		"igniteRandomPart",
		"breakRandomBeam",
		"deformRandomBeam",
		"deflateRandomTire"
	];

	function setFailures() {
		keyArray1.forEach(key => {
			bngApi.engineLua(`
				local veh = be:getObjectByID(${IDList[scope.agentyMechanicalFailureVeh]})
				if veh then
					veh:queueLuaCommand([[
						extensions.agentyMechanicalFailure.${scope[key]? "addFunction": "removeFunction"}("${key}")
					]])
				end
			`)
		})
	};

	const keyArray2 = [
		"ignoreEngineMounts",
		"ignoreRadiatorAndOilpan",
		"toggleRandomExplosion",
		"toggleRealisticDamage",
		"engineDeformationOnly",
		"lowerTireDeflationChance"
	];

	function setFailureSettings() {
		keyArray2.forEach(key =>{
			bngApi.engineLua(`
				local veh = be:getObjectByID(${IDList[scope.agentyMechanicalFailureVeh]})
				if veh then
					veh:queueLuaCommand([[
						extensions.agentyMechanicalFailure.${scope[key]? "setSettings": "unsetSettings"}("${key}")
					]])
				end
			`)
		})
	};

	const keyArray3 = [
		"breakRandomPartWheels",
		"breakRandomBeamWheels",
		"deformRandomBeamWheels"
	];

	const valueArr = [
		"breakRandomPart",
		"breakRandomBeam",
		"deformRandomBeam"
	];

	function setWheelSettings() {
		keyArray3.forEach((key, i) =>{
			bngApi.engineLua(`
				local veh = be:getObjectByID(${IDList[scope.agentyMechanicalFailureVeh]})
				if veh then
					veh:queueLuaCommand([[
						extensions.agentyMechanicalFailure.${scope[key]? "setWheelSettings": "unsetWheelSettings"}("${valueArr[i]}")
					]])
				end
			`)
		})
	};

	scope.mechanicalFailure = (withTimer)=>{
		if (!IDList[scope.agentyMechanicalFailureVeh]) return;

		setFailures();
		setFailureSettings();
		setWheelSettings();
		bngApi.engineLua(`
			local veh = be:getObjectByID(${IDList[scope.agentyMechanicalFailureVeh]})
			if veh then
				veh:queueLuaCommand([[
					extensions.agentyMechanicalFailure.${withTimer? "toggleDamageTimer": "mechanicalFailure"}(${withTimer? scope.secondsBetweenFailures : "nil"})
				]])
			end
		`)
	};

	scope.toggleDamageTimer = ()=>{scope.mechanicalFailure(true)};
}}}]);